/* Copyright (C) Krzysztof Strasburger, 2009
   licencja GNU GPL, wersja 2 lub pniejsza */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "mw3.h"

extern void blad();

static double rzut(double *v, double *v0, double rr0) {
	double c;
	c = adotb3(v, v0);
	if (c <= 0.)	/* nie trafia w ekran */
		return c;
	c = rr0 / c;	/* skalowanie wektora, by jego koniec lezal na ekranie */
	dscal3(v, c);
	aminusb3(v, v0, v);	/* W v otrzymujemy wektor na plaszczyznie ekranu */
	return sqrt(adotb3(v,v));	/* Zwracana jest dlugosc tego wektora */
}

/* static void uzycie(int ret) {
	printf("ekran odleglosc_ekranu_od_obserwatora\n");
	exit(ret);
} */

#define MAXNAZ	64
int main(int argc, char **argv) {
	double v[9],p[3],h,hmin,o,omin,c,rr,d1,d2,ca,sa,x,y;
	double d = 1000.;	/* fikcyjny "ekran" odlegly o 1000 m od obserwatora */
	double *w, *w0, *w1;
	char nazwa[MAXNAZ];
	int i;
	/* if (argc < 2)
		uzycie(-1);
	if (strcmp(argv[1],"-h") == 0)
		uzycie(0); */
	/* Odleglosc ekranu od obserwatora - rzecz zupelnie niepotrzebna */
	/* d = atof(argv[1]); */
	w = &v[0];
	/* Opuszczamy linie komentarza */
	for (i = getc(stdin); i == (int) '#' || i == (int) '\n'; i = getc(stdin)) {
		putc(i, stdout);
		while (putc(getc(stdin), stdout) != (int) '\n');
	}
	ungetc(i, stdin);
	i = 0;
	/* Wczytanie kolejnej linii danych */
	while(scanf("%lg %lg %lg %lg %lg %lg %lg %s",&o,&hmin,&omin,w,w+1,w+2,&h,nazwa) == 8) {
		if (strlen(nazwa) >= MAXNAZ)
			blad("Nazwa obieku jest za dluga.");
		switch(i) {
		case 0:		/* wektor wyznaczajacy srodek ekranu */
			c = d / sqrt(adotb3(w,w));	/* wspolczynnik skalujacy */
			dscal3(w, c);
			rr = d * d;
			w0 = w;
			w += 3;
			printf("# linia horyzontu jest na wysokosci %.1lf\n",hmin);
			break;
		case 1:		/* wektor wyznaczajacy dodatnia polos y (pion) */
			d1 = rzut(w, w0, rr);
			if (d1 <= 0.)	/* nie trafia w ekran */
				goto pomin;
			w1 = w;
			w += 3;
			printf("0.00000 %.5lf %.3lf %.1lf %.1lf %s\n",d1,o,h,hmin,nazwa);
			break;
		default:
			d2 = rzut(w, w0, rr);
			if (d2 <= 0.)	/* nie trafia w ekran */
				goto pomin;
			/* d2 - wspolrzedna biegunowa r;
			   znajdujemy kosinus i sinus kata */
			ca = adotb3(w, w1) / (d1 * d2);
			sa = 1. - ca * ca;
			/* zabezpieczenie przed niestabilnosciami numerycznymi */
			if (sa <= 0.)
				sa = 0.;
			else
				sa = sqrt(sa);
			/* Znak sinusa! Iloczyn wektorowy w1 i w ma kierunek
			   taki, jak wektor w0, wyznaczajacy srodek ekranu, */
			axb3(w1, w, p);
			/* ale jego zwrot moze byc przeciwny. */
			if (adotb3(w0, p) > 0.)
				sa = -sa;
			/* Obliczamy wspolrzedne kartezjanskie na ekranie. */
			/* Musimy pamietac, ze wektor w1 wyznacza pion, a nie poziom. */
			y = d2 * ca;
			x = -d2 * sa;
			printf("%.5lf %.5lf %.3lf %.1lf %.1lf %s\n",x,y,o,h,hmin,nazwa);
		}
		i++;
		continue;
pomin:
		fprintf(stderr,"Wektor prowadzacy do %s nie trafia w ekran.\n",nazwa);
	}
	return 0;
}
