/* Copyright (C) Krzysztof Strasburger, 2009
   licencja GNU GPL, wersja 2 lub pniejsza */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "wektor.h"
#include "disp.h"
extern void pokaz();
extern char *xmalloc();

extern char seplist[];

static FILE *g;
static char *tmpf;
static char *imgf;
static int nx, ny, x0, y0;
static int image = 0;

static char * strcmd() {
	char *par, *s;
	int n;
	par = strtok((char *) NULL, seplist);
	if (par) {
	/* Musimy skopiowac nazwe pliku roboczego, bo przepadnie przy nastepnej komendzie. */
		n = strlen(par) + 1;
		s = xmalloc(n);
		strcpy(s, par);
	} else
		s = (char *) NULL;
	return s;
}

/* static char * intcmd(int *k) {
	char *par;
	par = strtok((char *) NULL, seplist);
	if (par)
		*k = atoi(par);
	return par;
} */

static void gnuplot_init(){
	char *par;
	int n;
	/* Plik roboczy */
	tmpf = strcmd();
	if (!tmpf)
		blad("Trzeba podac nazwe pliku roboczego");
	/* Plik obrazu */
	imgf = strcmd();
	if (imgf) {
		/* Czytamy rozdzielczosc obrazu i pozycje srodka */
		par = strtok((char *) NULL, seplist + 2);
		n = sscanf(par,"%d %d %d %d",&nx,&ny,&x0,&y0);
		if (n < 2)
			blad("Trzeba podac rozdzielczosc obrazu.");
		if (n < 3)
			x0 = -nx / 2;
		if (n < 4)
			y0 = -ny / 2;
		if (nx <= 0 || ny <= 0)
			blad("Rozdzielczosci obrazu musza byc dodatnie.");
		image = 1;
	}
	g = popen("gnuplot -","w");
	/* g = fopen("output","w"); */
	if (!g) {
		perror("popen");
		blad("Nie powiodlo sie utworzenie lacza z programem gnuplot.");
	}
	setlinebuf(g);
	fprintf(g,"unset key\n");
	fprintf(g,"d0=0\nd1=100\nd2=100\nh1=1000\nh2=1000\n",y0,y0+ny);
	if (image) {
		fprintf(g,"set xrange [%d:%d]\n",x0,x0+nx);
		fprintf(g,"set yrange [%d:%d]\n",y0,y0+ny);
	}
}

static void gnuplot_fin(){
	pclose(g);
}

static void gnuplot_pokaz(struct wektor *w) {
	FILE *f;
	f = fopen(tmpf,"w");
	if (f) {
		pokaz(f, w);
		fclose(f);
		fprintf(g,"plot ");
		if (image)
			fprintf(g,"\"%s\" binary array=%dx%d format=\"%%uchar\" origin=(%d,%d) flipy with rgbimage,",imgf,nx,ny,x0,y0);
		fprintf(g,"\"%s\" using 1:2 with points pt 6,",tmpf);
		fprintf(g,"\"%s\" using 1:2:6:(d0+$5+($3-d1)/d2+($4-h1)/h2) with vectors nohead,",tmpf);
		fprintf(g,"\"%s\" using ($1+$6):($2+d0+$5+($3-d1)/d2+($4-h1)/h2):7 with labels\n",tmpf);
	} else
		perror("fopen");
}

static void gnuplot_cmd(char *s){
	fprintf(g,"%s\n",s);
}

struct dispfn gnuplot_fn = {
	gnuplot_init,
	gnuplot_fin,
	gnuplot_pokaz,
	gnuplot_cmd
};
