/* Copyright (C) Krzysztof Strasburger, 2009
   licencja GNU GPL, wersja 2 lub pniejsza */

/* Funkcja tworzaca macierze obrotu */
#include <stdio.h>
#include <math.h>
#include "mw3.h"

extern void blad();
/* Utworzenie macierzy obrotu m, o kat alfa, wokol osi przechodzacej przez
   poczatek ukladu wspolrzednych i punkt opisany wektorem w. */
void macierz_obrotu(double *m, double *w, double alfa) {
	double m1[9], m2[9]; /* macierze robocze */
	double ca, sa, ct, st, cf, sf; /* kosinusy i sinusy katow */
	double r;
	/* printf ("Macierz obrotu: %lf %lf %lf %lf\n",w[0],w[1],w[2],alfa); */
	r = sqrt(adotb3(w,w));
	/* Nasz punkt pokrywa sie z poczatkiem ukladu */
	if (r == 0.)
		blad("Wektor wyznaczajacy os obrotu ma zerowa dlugosc.");
	ca = cos(alfa); sa = sin(alfa);
	ct = w[2]/r; st = sqrt(1.-ct*ct); /* kosinus i sinus theta */
	r = r*st; /* rzut r na plaszczyzne xy */
	if (r == 0.) {
		cf = 1.; sf = 0.;
	} else {
		cf = w[0]/r; sf = w[1]/r;
	} /* kosinus i sinus phi */
	/* obrot ukladu wspolrzednych o phi wokol osi z */
	m[0] = cf; m[1] = sf; m[2] = 0.;
	m[3] =-sf; m[4] = cf; m[5] = 0.;
	m[6] = 0.; m[7] = 0.; m[8] = 1.;
	/* obrot ukladu wspolrzednych o theta wokol osi y */
	m1[0] = ct; m1[1] = 0.; m1[2] =-st;
	m1[3] = 0.; m1[4] = 1.; m1[5] = 0.;
	m1[6] = st; m1[7] = 0.; m1[8] = ct;
	mamul3(m1,m,m2);
	/* obrot punktu o alfa wokol osi z */
	m1[0] = ca; m1[1] =-sa; m1[2] = 0.;
	m1[3] = sa; m1[4] = ca; m1[5] = 0.;
	m1[6] = 0.; m1[7] = 0.; m1[8] = 1.;
	mamul3(m1,m2,m);
	/* obrot ukladu wspolrzednych o -theta wokol osi y */
	m1[0] = ct; m1[1] = 0.; m1[2] = st;
	m1[3] = 0.; m1[4] = 1.; m1[5] = 0.;
	m1[6] =-st; m1[7] = 0.; m1[8] = ct;
	mamul3(m1,m,m2);
	/* obrot ukladu wspolrzednych o -phi wokol osi z */
	m1[0] = cf; m1[1] =-sf; m1[2] = 0.;
	m1[3] = sf; m1[4] = cf; m1[5] = 0.;
	m1[6] = 0.; m1[7] = 0.; m1[8] = 1.;
	mamul3(m1,m2,m);
}
